using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace DinstantConsole
{
	class MainClass
	{
		private static Socket _s;

		public static void Main (string[] args)
		{
            int port = 0;
            foreach(var v in args)
            {
                try
                {
                    port = Convert.ToInt32(v);
                }
                catch(Exception ex)
                {
                    Console.WriteLine(ex.Message);
                }
            }
            if(port == 0)
            {
                Console.Write("Port: ");
                port = Convert.ToInt32(Console.ReadLine());
            }
            Connection.Port = port;

            var strHostName = Dns.GetHostName();
            Console.WriteLine("Version 1.0.1");
            Console.WriteLine("Local Machine's Host Name: " + strHostName);
            var ipEntry = Dns.GetHostEntry(strHostName);
            var addr = ipEntry.AddressList;
            for (var i = 0; i < addr.Length; i++)
            {
                Console.WriteLine("IP Address {0}: {1} ", i, addr[i].ToString());
            }
            Console.WriteLine("");

			try
			{
                var con = new Connection();
                con.Start();

                var notquit = true;
                while(notquit)
                {
                    notquit = Console.ReadLine() != "quit";
                }

                con.Stop();
			}
			catch (Exception e)
			{
				Console.WriteLine("Error..... " + e.StackTrace);
				Console.ReadKey();
			}

		}

		
		private static void StartReceive()
		{
			byte[] buffer = new byte[200];
			_s.BeginReceive(buffer, 0, 200, SocketFlags.None, (state) =>
			                {
				try
				{
					int bytesReceived = _s.EndReceive(state);
					for (int f = 0; f < bytesReceived; f++)
					{
						//Console.Write((char) buffer[f]);
                        ProcessChar((char)buffer[f]);
					}
					//Console.WriteLine(bytesReceived);

					if (bytesReceived != 0)
						StartReceive();
					else
						throw new Exception("got 0 data");
				}
				catch (Exception e)
				{
					Console.WriteLine("Error..... " + e.Message);
					Console.ReadKey();
				}
			}, null);
		}

		private static string ProcessBuffer = "";
		private static int ProcessPayloadLength = -1;
		private static bool FoundPipe1 = false;
		private static bool FoundPipe2 = false;
		private static void ProcessChar(char b)
		{
            try
            {
                if (!FoundPipe1)
                {
                    FoundPipe1 = b == '|';
                }
                else
                {
                    if (!FoundPipe2)
                    {
                        if (b == '|')
                        {
                            FoundPipe2 = true;
                        }
                        else
                        {
                            FoundPipe1 = false;
                        }
                    }
                    else
                    {
                        if (ProcessPayloadLength < 0)
                        {
                            ProcessBuffer += b;
                            if (ProcessBuffer.Length == 4)
                            {
                                ProcessPayloadLength = Convert.ToInt32(ProcessBuffer);
                                ProcessBuffer = "";
                                if (ProcessPayloadLength < 0)
                                {
                                    ProcessPayloadLength = 0;
                                }
                            }
                        }
                        else
                        {
                            ProcessBuffer += b;
                        }
                        if (ProcessPayloadLength == ProcessBuffer.Length)
                        {
                            Console.WriteLine(ProcessBuffer);
                            ResetProcessBuffer();
                        }
                    }
                }
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex.Message);
                ResetProcessBuffer();
            }
		}

        private static void ResetProcessBuffer()
        {
            FoundPipe1 = false;
            FoundPipe2 = false;
            ProcessPayloadLength = -1;
            ProcessBuffer = "";
        }
	}
}
